import string
from cStringIO import StringIO

from Products.CMFCore.utils import getToolByName

def install(portal):
    setup_tool = getToolByName(portal, 'portal_setup')
    setup_tool.setImportContext('profile-FireBugger:firebugger')
    setup_tool.runAllImportSteps()
    setup_tool.setImportContext('profile-CMFPlone:plone')
    return "Ran all import steps."

def uninstall(self):
    """ removes what GenericSetup doesn't """

    out = StringIO()

    # configlet
    cp = getToolByName(self,'portal_controlpanel')
    cp.unregisterConfiglet('firebugger')
    out.write('Unregistered Firebugger configlet.\n')

    # properties
    portal = getToolByName(self, 'portal_url').getPortalObject()
    portal.manage_delProperties(ids=['firebugger_state',])
    out.write('Removed firebugger_state property from portal.\n')
    
    # skin layers
    skins = ['firebug','firebugger']
    skinstool = getToolByName(self, 'portal_skins')
    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName)
        path = [i.strip() for i in  path.split(',')]
        for s in skins:
            if s in path:
                path.remove(s)
            s += '/'
            for layer in path:
                if layer.startswith(s):
                    path.remove(layer)
        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)
    out.write('Removed FireBugger skin layers.\n')


    return out.getvalue()
